/**
 * Classe: JanCategoria
 * Autor:  IvanMecenas
 * Data:   20/12/2002
*/
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class JanCategoria extends JFrame {

  private JLabel label1 = new JLabel("Categoria");
  private JTextField edArgumento = new JTextField();
  private JTextArea textArea = new JTextArea();
  private JScrollPane scroller = new JScrollPane();

  public JanCategoria() {
    iniciaComponentes();
  }

  public void iniciaComponentes() {

    this.getContentPane().setLayout(null);
    this.setSize(483, 378);
    this.setLocation(158, 111);
    this.setTitle("Banco Northwind - Pesquisa Categorias");
    this.setResizable(false);

    label1.setBounds(new Rectangle(28, 40, 57, 13));
    this.getContentPane().add(label1, null);

    edArgumento.setBounds(new Rectangle(90, 34, 150, 21));
    this.getContentPane().add(edArgumento, null);
    edArgumento.addFocusListener (new FocusAdapter() {
      public void focusLost(FocusEvent e) {
        // Chamada ao Procedimento
        edArgumentoAoPerderFoco(e);
    }});

    textArea.setBounds(new Rectangle(28, 70, 420, 260));
    this.getContentPane().add(textArea, null);
    scroller.setBounds(new Rectangle(28, 70, 420, 260));
    scroller.getViewport().add(textArea, null);
    this.getContentPane().add(scroller, null);
    this.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        aoFechar();
      }
    });
  }

  private void aoFechar() {
    dispose();
  }

  private void edArgumentoAoPerderFoco(FocusEvent e) {
    int regs;
    String qry;
    String[][] reg;

    //Retira brancos do argumento
    edArgumento.setText(edArgumento.getText().trim());

    //Estabelece conexo
    ConexaoAccess ac =
      new ConexaoAccess("jdbc:odbc:Northwind", "", "");

    if (ac.conecta()) {
      //Monta cabealho da textArea
      textArea.append("Cdigo\tNome\n");

      //Monta query
      qry = " SELECT COUNT(*) FROM Categorias ";

      //Recupera a quantidade de registros
      if ((regs = ac.regCount(qry)) > 0) {
        reg = new String[regs][2];
      }
      else {
        ac.desconecta();
        return;
      }

      //Monta query
      qry = " SELECT CdigoDaCategoria "
          + "      , NomeDaCategoria "
          + " FROM Categorias ";

      //Verifica se o argumento de pesquisa foi informado
      if (!(edArgumento.getText().trim().equals("")))
        qry = qry
            + " WHERE CdigoDaCategoria = "
            + edArgumento.getText();

      //Recupera os dados da categoria
        ac.getColumn(qry, reg, regs);

      //Preenche textArea
        textArea.setText("");
        for (int lin = 0; lin < regs; lin++) {
          if (reg[lin][0] != null)
            textArea.append("" + reg[lin][0] + "\t" + reg[lin][1] + "\n");
        }

      //Desconecta
      ac.desconecta();
    }
  }
}