/*
 * ConexaoInterbase.java
 *
 * Created on 13 de Outubro de 2002, 11:42
 */

// Importa pacotes
import java.awt.*;
import javax.swing.*;
import java.util.*;
import java.sql.*;

/**
 * CLASSE ConexaoInterBase
 * Autor: Ivan Mecenas
 * Data : 13/10/2002
*/
public class ConexaoInterbase {

  final static private String DRV = "org.firebirdsql.jdbc.FBDriver";
  private String url = "jdbc:firebirdsql:localhost/3050:" +
    "C:\\Program Files\\Firebird\\examples\\Employee.gdb";
  private String userName = "sysdba";
  private String password = "masterkey";
  private Connection conn;
  private Statement st;

  public boolean conecta() {
    boolean result = true;
    try {
      Class.forName(DRV);
      conn = DriverManager.getConnection(url, userName, password);
    }
    catch(java.lang.ClassNotFoundException erroClass) {
      mensagemErro(erroClass.getMessage());
      result = false;
    }
    catch(SQLException erroSQL) {
      mensagemErro(erroSQL.getMessage());
      result = false;
    }
    return result;
  }

  public void desconecta() {
    boolean result = true;
    try {
      conn.close();
    }
    catch(SQLException erroSQL) {
      mensagemErro(erroSQL.getMessage());
      result = false;
    }
  }

  public int regCount(String qry) {
    int result = 0;
    try {
      st = conn.createStatement();
      ResultSet rs = st.executeQuery(qry);
      rs.next();
      result = rs.getInt(1);
      st.close();
    }
    catch(SQLException sqlex) {
      mensagemErro(sqlex.getMessage());
    }
    return result;
  }

  public int exeQuery(String qry) {
    int result = 0;
    try {
      st = conn.createStatement();
      result = st.executeUpdate(qry);
      st.close();
    }
    catch(SQLException sqlex) {
      mensagemErro(sqlex.getMessage());
    }
    return result;
  }

  public String getColumn(String qry) {
    String result = "";
    try {
      st = conn.createStatement();
      ResultSet rs = st.executeQuery(qry);
      rs.next();
      result = rs.getString(1);
      st.close();
    }
    catch(SQLException sqlex) {
      mensagemErro(sqlex.getMessage());
    }
    return result;
  }

  public void getColumn(String qry, String[] reg) {
    try {
      Statement st = conn.createStatement();
      ResultSet rs = st.executeQuery(qry);
      rs.next();
      for (int i = 1; i <= reg.length; i++)
        reg[i-1] = rs.getString(i);
      st.close();
    }
    catch(SQLException sqlex) {
      mensagemErro(sqlex.getMessage());
    }
  }

  public void getColumn(String qry, String[][] reg, int lin) {
    try {
      System.out.println(qry);
      st = conn.createStatement();
      ResultSet rs = st.executeQuery(qry);
      for (int i = 1; i <= lin; i++) {
        if (rs.next())
          for (int n = 1; n <= reg[n].length; n++ )
            reg[i-1][n-1] = rs.getString(n);
      }
      st.close();
    }
    catch(SQLException sqlex) {
      mensagemErro(sqlex.getMessage());
    }
  }

  public void setURL(String valor) {
    url = valor;
  }

  public void setUserName(String valor) {
    userName = valor;
  }

  public void setPassword(String valor) {
    password = valor;
  }

  private void mensagemErro(String msg) {
    JOptionPane.showMessageDialog(
      null,
      msg,
      "Erro",
      JOptionPane.ERROR_MESSAGE);
  }
}